
Import "fx.bmx"
Import "vehtori.bmx"

SetGraphicsDriver GLMax2DDriver()

Const WIDTH=1024,HEIGHT=768,DEPTH=32

Graphics WIDTH,HEIGHT,DEPTH

HideMouse()

Global nyte#

'Fix Blitz screen coordinates
glMatrixMode GL_PROJECTION
glLoadIdentity
glOrtho -400,400, 300,-300, 0, 1000
glMatrixMode GL_MODELVIEW

fx_init WIDTH,HEIGHT

Global efektiarvo#[20]
Local filtteriarvo#[20]

Local sgenet:Byte Ptr[4]

set_path("data/".ToCstring())

sgenet[0]=load_scene("tesno1.obj".ToCstring())
sgenet[1]=load_scene("tesno2.obj".ToCstring())
sgenet[2]=load_scene("tesno3.obj".ToCstring())
sgenet[3]=load_scene("tesno4.obj".ToCstring())

musa=LoadSound("data/sisakurvi.ogg")

Local txt[8]

txt[0]=LoadImage("data/txt1.png")
txt[1]=LoadImage("data/txt2.png")
txt[2]=LoadImage("data/txt3.png")
txt[3]=LoadImage("data/txt4.png")
txt[4]=LoadImage("data/txt5.png")
txt[5]=LoadImage("data/txt6.png")
txt[6]=LoadImage("data/txt7.png")
txt[7]=LoadImage("data/txt8.png")

Local rob[6]

rob[0]=LoadImage("data/rob1.png")
rob[1]=LoadImage("data/rob2.png")
rob[2]=LoadImage("data/rob3.png")
rob[3]=LoadImage("data/rob4.png")
rob[4]=LoadImage("data/rob5.png")
rob[5]=LoadImage("data/rob6.png")

flare=LoadImage("data/flare.png")

For n=0 To 7
	MidHandleImage(txt[n])
Next

For n=0 To 5
	MidHandleImage(rob[n])
Next

fxpmaara=100

Local fxx#[fxpmaara]
Local fxy#[fxpmaara]
Local fxr[fxpmaara]
Local fxan#[fxpmaara]
Local fxrotta[fxpmaara]

For a = 0 To fxpmaara-1

	fxr[a]=Rnd(359)
	fxan#[a]=Rnd(300)
	fxrotta[a]=Rnd(359)
	If fxan#[a]>800 Then fxan#[a]=1

	fxan#[a]=fxan#[a]+(fxan#[a]/15)+1
	
Next

alku#=MilliSecs()

SeedRnd MilliSecs()

For pera=0 To 10
	efektiarvo#[pera]=1+Rnd(99)
Next

For pera=0 To 10
	filtteriarvo#[pera]=1+Rnd(100)
	Print filtteriarvo#[pera]
Next

efekti=2
filtteri=1+Rnd(8)
kuva=2

robox1=-200
rops=0

PlaySound musa

While Not KeyHit(KEY_ESCAPE)

	SetBlend (LIGHTBLEND)
	SetAlpha (0.5)

	nyte#=MilliSecs()-alku#
	If nyte#/1000>195 Then End
	
	SetScale (1,1)
	efarpa=Rnd(200)
	fiarpa=Rnd(100)
	kuarpa=Rnd(100)
	deearpa=Rnd(30)
		
	If efarpa=40
		efekti=1+Rnd(7)
		
		SeedRnd MilliSecs()
		
		For pera=0 To 10
			efektiarvo#[pera]=1+Rnd(99)
		Next
	EndIf
	
	If fiarpa=50 
		filtteri=1+Rnd(11)
	
		SeedRnd MilliSecs()
		
		For pera=0 To 10
			filtteriarvo#[pera]=1+Rnd(100)
		Next
	EndIf

	If kuarpa=40
		kuva=Rnd(30)	
		SeedRnd MilliSecs()
	EndIf
	
	If efekti=1 Then Goto efekti1
	If efekti=2 Then Goto efekti2
	If efekti=3 Then Goto efekti3
	If efekti=4 Then Goto efekti4
	If efekti=5 Then Goto efekti1
	If efekti=6 Then Goto efekti1
	If efekti=7 Then Goto efekti1
	If efekti=8 Then tesno_opjekti(sgenet[1])
	If efekti=9 Then tesno_opjekti(sgenet[2])
	If efekti=10 Then tesno_opjekti(sgenet[3])
	If efekti=11 Then tesno_opjekti(sgenet[4])

	#ehvu
	
    ' Tuli nin lyhyt ja ytimeks

	If deearpa=10
		dee=Rnd(10)
		
		SeedRnd MilliSecs()
		
	EndIf

	If dee<4 Then tesno_opjekti(sgenet[dee])
	
	SetRotation(0)
	DrawImage rob[robonum],xarvo,70	
	
	If filtteri=1 Then Goto filtteri1
	If filtteri=2 Then Goto filtteri2
	If filtteri=3 Then Goto filtteri3
	If filtteri=4 Then Goto filtteri4
	If filtteri=5 Then Goto filtteri5
	If filtteri=6 Then Goto filtteri6
	If filtteri=7 Then Goto filtteri7
	If filtteri=8 Then Goto filtteri8
	If filtteri=9 Then Goto filtteri9				
	If filtteri=10 Then Goto filtteri10
	If filtteri=11 Then Goto filtteri11
	#filsu

    ' Ja tkin siistiyty
	If kuva<8 Then kuvatus(txt[kuva])
	
	' Uus ropootirutiini, robotimen jakaja mr nopeuden
	robotime#=nyte#/15.0
	xarvo=robotime# Mod 1600 -800
	robonum=Int(robotime#/1600) Mod 6 ' nollasta viiteen

	SetRotation(0)
	SetScale(1,1)
	SetAlpha(1)
	SetBlend(ALPHABLEND)
	DrawImage rob[robonum],xarvo,70		

	Flip
	glwipe
Wend

End

Function kuvatus(kuv:TImage)
	SetScale(2+efektiarvo[7]/90,2+efektiarvo[7]/90)
	SetRotation(Rnd(5))
	SetAlpha (1)
	DrawImage kuv,(efektiarvo[6])+Rnd(30),(efektiarvo[5])+Rnd(30)
	SetRotation(Rnd(5))
	SetAlpha (0.5)
	DrawImage kuv,(efektiarvo[6])+Rnd(30),(efektiarvo[5])+Rnd(30)
	SetRotation(Rnd(5))
	SetAlpha (0.2)
	DrawImage kuv,(efektiarvo[6])+Rnd(30),(efektiarvo[5])+Rnd(30)
End Function

#filtteri1
'r,g,b,length,rota
fx_shine filtteriarvo#[1]/100,filtteriarvo#[2]/100,filtteriarvo#[3]/100, filtteriarvo#[4]/100,filtteriarvo#[5]/100
Goto filsu

#filtteri2
fx_squareblur filtteriarvo#[1]/2,0,1 ,filtteriarvo#[2]/100,filtteriarvo#[3]/100,filtteriarvo#[4]/100
Goto filsu

#filtteri3
fx_squareblur filtteriarvo#[1]/2,1,1 ,filtteriarvo#[2]/100,filtteriarvo#[3]/100,filtteriarvo#[4]/100
Goto filsu

#filtteri4
fx_squareblur filtteriarvo#[1]/2,1,0 ,filtteriarvo#[2]/100,filtteriarvo#[3]/100,filtteriarvo#[4]/100
Goto filsu

#filtteri5
fx_squareblur filtteriarvo#[1]/2,0,0 ,filtteriarvo#[2]/100,filtteriarvo#[3]/100,filtteriarvo#[4]/100
Goto filsu

#filtteri6
fx_kaleido 1,filtteriarvo#[1]/10
Goto filsu

#filtteri7
fx_separatergb Sin(x#*4)/(30.0+filtteriarvo#[1]/3),0
Goto filsu

#filtteri8
fx_separatergb Sin(x#*4)/(30.0+filtteriarvo#[1]/3),0
fx_squareblur 40,1,1 ,1,1,1
Goto filsu

#filtteri9
fx_kaleido 1,filtteriarvo#[1]/10
fx_squareblur filtteriarvo#[1]/2,0,1 ,filtteriarvo#[2]/100,filtteriarvo#[3]/100,filtteriarvo#[4]/100
Goto filsu

#filtteri10
fx_kaleido 1,filtteriarvo#[1]/10
fx_shine filtteriarvo#[1]/100,filtteriarvo#[2]/100,filtteriarvo#[3]/100, filtteriarvo#[4]/100,filtteriarvo#[5]/100
Goto filsu

#filtteri11
fx_kaleido 1,filtteriarvo#[1]/10
fx_separatergb Sin(x#*4)/(30.0+filtteriarvo#[1]/3),0
Goto filsu


#efekti1
	
ra#=nyte#/15
simi#=Sin(ra#)*(efektiarvo#[1]/2)
r#=nyte#/(efektiarvo#[2]/10)
	
For t=0 To 359
	
	While r#>360
		r#=r#-360
	Wend
		
	r#=r#+2.5
	si#=Sin(r#)*efektiarvo#[6]/2

	sx1#=Sin(t)*(100+si#)
	sy1#=Cos(t)*(100+si#)
	sx2#=Sin(t-(si#/5)+simi#)*((100+si#)+simi#)
	sy2#=Cos(t-(si#/5)+simi#)*((100+si#)+simi#)
	
	SetColor 100,100,100
	SetLineWidth efektiarvo#[4]/2

	For n=1 To 5
		
		If n=1 Then di#=4
		If n=2 Then di#=2
		If n=3 Then di#=1
		If n=4 Then di#=0.5
		If n=5 Then di#=0.25
			
		DrawLine sx1#/di#,sy1#/di#, sx2#/di#,sy2#/di#
	Next
Next
	
x#=Sin((MilliSecs()-nyte#)/efektiarvo#[5]/10)*(efektiarvo#[3])+180
	
Goto ehvu
End

#efekti2

	SetColor(100,simo,simo)

	aas#=nyte#/(efektiarvo#[1]/3)
	
	simo=150+Sin(aas#)*efektiarvo#[1]*3

	For a = 0 To fxpmaara-1
		fxan#[a]=fxan#[a]+(fxan#[a]/15)+1
		SetAlpha(0.1+(fxan#[a]/650))
		If fxan#[a]>700 Then fxan#[a]=1
		SetRotation(aas#)
		fxx#[a]=Sin(fxr[a]+aas#)*(10+fxan#[a])
		fxy#[a]=Cos(fxr[a]+aas#)*(10+fxan#[a])
		
		DrawImage flare,fxx#[a],fxy#[a]

	Next
Goto ehvu

#efekti3

	SetColor(100,simo,simo)

	aas#=nyte#/(efektiarvo#[1]/3)
	
	simo=150+Sin(aas#)*efektiarvo#[1]*3

	For a = 0 To fxpmaara-1
		fxan#[a]=fxan#[a]+(fxan#[a]/15)+1
		SetAlpha(0.1+(fxan#[a]/650))
		If fxan#[a]>700 Then fxan#[a]=1
		SetRotation(aas#)
		fxx#[a]=Sin(fxr[a]+aas#)*(10+fxan#[a])
		fxy#[a]=Cos(fxr[a]+aas#)*(10+fxan#[a])
		
		DrawImage txt[6],fxx#[a],fxy#[a]

	Next
Goto ehvu

#efekti4

	SetColor(100,simo,simo)

	aas#=nyte#/(efektiarvo#[1]/3)
	
	simo=150+Sin(aas#)*efektiarvo#[1]*3

	For a = 0 To fxpmaara-1
		fxan#[a]=fxan#[a]+(fxan#[a]/15)+1
		SetAlpha(0.1+(fxan#[a]/650))
		If fxan#[a]>700 Then fxan#[a]=1
		SetRotation(aas#)
		fxx#[a]=Sin(fxr[a]+aas#)*(10+fxan#[a])
		fxy#[a]=Cos(fxr[a]+aas#)*(10+fxan#[a])
		
		DrawImage txt[7],fxx#[a],fxy#[a]

	Next

Goto ehvu

Function tesno_opjekti(sgene:Byte Ptr)

	glsetup 2
	gllite 0, 20,10,0, 1	' Light setup
	gllite 1, -20,-10,0, 1

	glLoadIdentity
	glTranslatef 0,-0,-6
	glRotatef nyte#/6.0, 0,0.3,1
	render_scene sgene,RENDER_NORMAL

		gldone
	' GL code end
End Function

End